###
### Monkey patch to make ZWiki be able to render Latex stuff
### Sean 9.01
###

from ReplaceInlineLatex import replaceInlineLatex

from Products.ZWiki.ZWikiPage import ZWikiPage
from Products.ZWiki.Regexps import protected_line, interwikilink, wikilink
from Products.ZWiki.ZWikiPage import thunk_substituter
from OFS.DTMLDocument import DTMLDocument
import re

# structured text + HTML +wiki links + LaTeX code
def render_structuredtextlatex(self, client=None, REQUEST={},
                               RESPONSE=None, **kw):
    # prerender (zwiki 0.11 requires this?)
    t = str(self.read())
    if not self._prerendered:
        get_transaction().note('prerender')
        self._prerendered = t or '\n'
        self.cook()                             # pre-parse DTML
    if kw.get('pre_only',0): return
    latexTemplate = None
    latexTemplatePage = getattr(self._my_folder(),
                                'LatexTemplate', None)
    if latexTemplatePage:
        latexTemplate = latexTemplatePage.text()
    t = self.applyLineEscapesIn(t)
    t = apply(DTMLDocument.__call__,(self, client, REQUEST, RESPONSE), kw)
    t = replaceInlineLatex(t, latexTemplate)
    t = self.stxToHtml(t)                   # must be done after latex
    t = self.renderLinksIn(t)
    t = apply(self.addStandardLayoutTo,(t,),kw)
    return t

ZWikiPage.render_structuredtextlatex = render_structuredtextlatex
ZWikiPage.ZWIKI_PAGE_TYPES = ZWikiPage.ZWIKI_PAGE_TYPES + ('structuredtextlatex',)
